// Frozty Free-Space ..

// A nice util to show the free space on several disks
// and a summary of total/used space on all listed drives...
// All of this in FrozText of course!

// Coded By The Thought Of Frozty in 1996

// Call +46-240-17917 NOW!

#include <stdio.h>
#include <dos.h>
#include <process.h>
#include <string.h>
#include <ctype.h>

void diskfree(int);					// Gets Free Space for one drive
void Space( long, long);			// Shows Free Space
void Space2( long, long); 			// Shows avail/total for current drive

void showinfo(void);					// Displays help and info

void Froztf( char[], char );		// Prints the string in FrozText
void Color( unsigned int );		//	Changes the Color used

long t_avail, t_total; // mb free for all drives

// *********** MAIN PROGRAM ************

int main(int argc, char *argv[])
{
   int i;
   unsigned disk;

	printf( "%c[2J" , 27);  // Screen Clear
   Froztf( "                  .+: Frozty Free-Spaze v 1.2 :+.\n\n", '6');

	t_avail = 0;
	t_total = 0;

	if( argc > 1 )
	{
		if( !strcmp( argv[1], "?" ) )
		{
			showinfo();
			return 0;
		}
		else if( !strcmp( argv[1], "/?" ) )
		{
			showinfo();
			return 0;
		}

		else
		{
         for(i=1; i<argc; i++)
			{
				if( isalpha( (int) *argv[i] ) )
				{
					diskfree( (*argv[i] & ~0x20)	- 64 );
				}
				else
				{
					Froztf( "Argument ", '1');
					printf( "%i", i);
					Froztf( " invalid! (Type FZ-FREE ? for help!)\n", '1');
				}
			}

			if( argc > 2 )			// skriv bara total om fler n 1 drive.
			{
				Froztf("\nTotal:   ", '6');
				Space( t_avail, t_total );
			}
		}
	}
	else		// inga argument.. visa freespace p current drive..
	{
		_dos_getdrive( &disk );
		diskfree( disk );
	}

	Froztf( "\n               Coded by The Thought of Frozty in 1996!\n\n", '7');
	Color( 7 );

	return 0;
}

void showinfo(void)
{
		Froztf( "Enter Drives To Be Shown With Spaces Between.\n\n", '1');
		Froztf( "Example:  FZ-FREE a         Show Free Space On Drive A\n", '6');
		Froztf( "          FZ-FREE c d e     Show Free Space On Drives C, D And E\n\n", '6');
		Froztf( "              .+: Frozty - The C00Lest Board Ever!! :+.\n", '5');
}

void diskfree( int disk )
{
	long avail, total;
	struct diskfree_t free;

	if (_dos_getdiskfree(disk, &free) != 0)
	{
		printf( "Drive %c error!\n", (char) disk+64);
		return;
	}

	avail = (long) free.avail_clusters
			* (long) free.bytes_per_sector
			* (long) free.sectors_per_cluster >> 10;

	total = (long) free.total_clusters
			* (long) free.bytes_per_sector
			* (long) free.sectors_per_cluster >> 10;

	t_avail += avail;
	t_total += total;

	Froztf("Drive ", '6');
	Color( 17 );
	printf("%c", (char) disk+64);
	Color( 7 );
	printf(": ");

	Space( avail, total );

	return;
}

void Space( long avail, long total)
{
	int avail_chars = 49 - (int) ( (avail * 50) / total);
   int i;

	Color( 16 );
	putchar('[');
	Color( 14 );

   for( i=0; i<50 ; i++)
	{
		if( i > avail_chars )
			putchar( 250 );
		else
			putchar('*');
	}

	Color( 16 );
	putchar(']');

	if( total > 10000 )
	{
		total >>= 10;
		avail >>= 10;
		Space2( avail, total );
		Color(7);
		putchar('M');
	}
	else
	{
		Space2( avail, total );
		Color(7);
		putchar('K');
	}

	Color(10);
	printf("b - ");
	Color( 12 );
	printf("%d" , (avail*100) /total );
	Color( 2 );
	printf(" \%\n");
}

void Space2( long avail, long total)
{
	Color( 16 );
	printf(" %ld", avail);
	Color( 6 );
	putchar('/');
	Color( 16 );
	printf("%ld ", total );
}


/* **********************************
	*                                *
	*				ANSI Functions   		*
	*											*
	********************************** */

void Froztf( char *in, char color)
{
   int i;

   for(i=0; i < strlen(in) ; i )
	{
		if( in[i] == 32 )
		{
			i++;
			putchar(' ');
		}
		else
		{
			printf( "%c[1;3%cm%c",27, color, in[i++] );

			printf( "%c[0;3%cm",27, color);

			for( ; in[i]!=32 && i < strlen(in) ;i++)
				putchar( in[i] );
		}
	}
}

void Color(unsigned int color)
{
	if( (color > 7 && color < 10) || color > 17 )
	{
		printf("Invalid color %i specified!\n", color);
		return;
	}
	else
	{
		printf("%c[",27);

		if( color > 9)
		{
			putchar('1');
			color -= 10;
		}
		else
			putchar('0');

		printf(";3%cm", (char) color+48);
	}
}


